#ifndef __SPINS_H
#define __SPINS_H 1

#include <stdlib.h>	/* Achtung bei long<->int-Mischmasch */
#include <stdio.h>
#include <string.h>	/* strcat, strcmp, usw. */
#include <math.h>
#include "spinsdef.h"	/* define Lsize Dsize Isize etc. */
#include "config.h"
#include "sighand.h"	/* signalhandler -> ini_handler, sig1 */
#include "defs.h"
#include "modeldef.h"	/* specialy system */
#include "mem.h"

extern int	algo;	/* 0=lanzcos,1=richter,2=wenzel2x2 */
extern int	x_p;	/* Darstellungsform fuer |x> <=3 */
extern int      save_mode; /* setup after crash possible */
extern int      checkpoint; /* setup after crash possible */

/* die folgenden Macros sollten nicht hier geaendert werden,
   sondern in config.h
   eingetragen werden (here only default values) */
/* IFz(x) lieferte auf cray cpp-error, daher wieder einfacher 1998-148 */
#ifndef IFz		/* may be predefined in config.h */
#define IFz	1  	/* 1 = XYZ-JJ-model, 0 = XY-JJ-model */
#endif
#ifndef NEW
#define NEW	4	/* Zahl zu berechnender Eigenwerte    >=NEV,>NE0 */
#endif
#ifndef NEV
#define NEV	4	/* max. Zahl zu berechn. Eigenvektoren <=(NEW-NE0) */
#endif
#ifndef NE0
#define NE0	0	/* Anregung des ersten zu bestimmenden EVs <NEW */
#endif
#define code2	0	/* 1=u's and d's hintereinander! only tU,tJ, 0=old */

/* besser mit code2 arbeiten, dann braucht man kein MAA und M55 */
/* last mod: 1998-148 cray-cc don not accept 0LL */
#if defined(S_llong) &&  NN > CM(8,4,4)*S_long
/* ========================== long long =============================== */
#if 0
#define MAA   (0xAAAAAAAAAAAAAAAAULL)	/* 64bit Bitmuster alles down's */
#define M55   (0x5555555555555555ULL)	/* 64bit Bitmuster alles up's */
#endif
#if     NN <8*S_llong
#define M0F   ((1ULL<<NN)-1)
#elif   NN==8*S_llong
#define M0F   (~0ULL)
#else
#define M0F   ((((tbase)1)<<NN)-1)
/* #error "NN>8*sizeof(llong)" */
#endif
#else
/* ========================== long ==================================== */
#if   S_long == 8
#if 0
#define MAA   (0xAAAAAAAAAAAAAAAAUL)	/* Bitmuster alles down's */
#define M55   (0x5555555555555555UL)	/* Bitmuster alles up's */
#endif
#elif S_long == 4
#if 0
#define MAA   (0xAAAAAAAAUL)		/* Bitmuster alles down's */
#define M55   (0x55555555UL)		/* Bitmuster alles up's */
#endif
#else
#error "sizeof(long) not 4 or 8"
#endif  
#if     NN <8*S_long
#define M0F   ((1l<<NN)-1)
#elif   NN==8*S_long
#define M0F   (~0l)
#else
#define M0F   ((((tbase)1)<<NN)-1)
/* #error "NN>8*sizeof(long)" */
#endif
#endif

#ifndef CM			/* CaseModel => config.h */
#error define CM(JJ,tJ,tU) JJ	/* default=JJ else tJ or tU model */
#endif

#ifndef N0
#define N0 NN
#endif

/* Speichersparender Typ fuer Basis-Konfigurationen dN..d1 uN..u1 */
/* cray: sizeof() short=int=long=longlong! aber bits sind verschieden!? */
/* 1998-148: cray (short)0100=0000 (short)0080=ff80 !?
   1998-150: tbase1=1bit/site, tbase = CM ( tbase1, tbase[u,d], .. )
   2002apr: Nd,...,3d,2d,1d,Nu...,3u,2u,1u in one word
 */
#if   CM( 1* , 2* , 2* ) NN<=8*S_char   &&  S_char  < S_short
  typedef unsigned char      tbase1;				/* CHAR_BIT = 8 */
#elif CM( 1* , 2* , 2* ) NN<=8*S_short  &&  S_short < S_int
  typedef unsigned short     tbase1;
#elif CM( 1* , 2* , 2* ) NN<=8*S_int
  typedef unsigned int       tbase1;
#elif CM( 1* , 2* , 2* ) NN<=8*S_long
  typedef unsigned long      tbase1;
#elif defined(S_llong) && (CM( 1* , 2* , 2* ) NN<=8*S_llong)
  typedef unsigned long long tbase1;
#else
# define B2size ( CM( 1* , 2* , 2* ) ((NN-1)/(8*S_int)+1)) /* int=fastest */
/* Bsize=(B2size*S_int) */
#include "vlint.h"
typedef class vlint tbase1;
/* # error NN>8*S_long not supported at the moment! */
#endif
typedef tbase1 tbase;

#include "symmetry.h"	/* need declaration of tbase1 */

/* ------- class base_ => b_ ----------------------------------- */
#define MaxSBase	(2*MaxSym+2)	/* should be larger than 2*MaxSym+1 */
struct sbase{		/* viel memory, ueber spez. fkt speicher zuordnen */
  tbase  skfg;		/* b_smallest */
  ULLong norm2;		/* norm^(-2),   <kfg|skfg)  N=10 S=5/2 norm2>1e9 */
  tphase sign;		/* phase, real=int=+1,-1 */
  int    num;		/* number of configs (mostly 2*MaxSym+2) */
  int    o;		/* option: 0=fullbase,1=smallest,2=ifsmallest */
  tbase  ib[MaxSBase];	/* large object -> class for array proof? */
  tphase is[MaxSBase];};

extern ULong  n1,n2;			/* Matrixsize , Linsize      */
extern int	pew;			/* number eigenvalue to check */
/* extern zahl a[MAX_ITR+1]; */
/* extern zahl b[MAX_ITR+1]; */		/* a,b Tridiagonalmatrix	*/
/* extern zahl c[MAX_ITR+1][NEV+1]; */	/* Eigenvektoren der TridiagMatrix */
extern zahl ew[NEW];                 	/* Eigenwerte     (max 4)	*/
/* extern mcplx ev[NEV][N1]; */		/* Eigenvektoren  (max 4)	*/
/* extern mcplx v0[N1],v1[N1],v2[N1];*/	/* Zustandsvektoren fuer Iteration */
extern FILE *f1;			/* Ausgabefile			*/
extern ULong *base2;
#ifndef Tnorm2
/* ERR(600): set this to char, short, int or long (memory is increasing!) */
#define Tnorm2 char		/* range for 0..255^sizeof(Tnorm2) */
#endif
extern Tnorm2 *norm2;		/* vector idx->sym-idx, norm(sym-idx)	*/
extern minfo_t m_n2;            /* memory status info for norm2-array */
extern int  base2ok;		/* flag: norm2 is initialized		*/
extern ULong h_n1;		/* Anz. in hxy gespeicherter Zeilen	*/
extern ULong h_nn;		/* Anz. NZ-Elemente in h_n1 Zeilen	*/
extern ULong h_nz;		/* Anz. NZ-Elemente in allen Zeilen 	*/
extern ULong hfmax;		/* max. Zahl von hxy[] auf Platte	*/
#if 0				/* never defined, better than comments?	*/
 extern cplx sqrt(x)cplx x;{return(pow(x,0.5));}/* only for buggy GNUC	*/
#endif

	/* Flip(kfg,i1,i2) kfg^flip[i1][i2] last change: 9.4.1998 JS */
#if   CM(1,0,0)
#define Flip(kfg,i1,i2) ((kfg) ^ ((tbase)1)<<(i1) ^ ((tbase)1)<<(i2))
#elif CM(0,1,1)				/* u<=>d sites i,j */
# if code2
#define Flip(kfg,i1,i2) ((kfg) ^ ((tbase)1)<<(i1   ) ^ ((tbase)1)<<(i2   ) \
                               ^ ((tbase)1)<<(i1+NN) ^ ((tbase)1)<<(i2+NN) )
# else					/* u<=>d sites i,j */
#define Flip(kfg,i1,i2) ((kfg) ^ ((tbase)3)<<((i1)*2) ^ ((tbase)3)<<((i2)*2) )
# endif
#endif

/* NZXMAX max. num of matrix elements of one line, enlarge it if neccessary */
#define NZXMAX	1024
/* --------------- this is for parallelizable code ------------- */
typedef struct shbuf {	/* puffer fuer eine Hamiltonzeile */
  int n,block;		/* num_elements, blockNo. */
  tvec *v0, *v1;        /* pointer to v0, v1 (v1+=H*v0) */
  cplx r;               /* r=<v1|H|v0>_block */
  /* add sbase b1, b2 for more simple nhm??? */
  struct shelem {
    tbase kj;
    ULong j;
    cplx  r;
    /* add norm2 for better wopij()??? */
  } el[NZXMAX];
} thbuf;

/*  thbuf *hbuf; hbuf=alloc_hbuf(); ... free_hbuf(hbuf); */
thbuf *alloc_hbuf( void );
void  *free_hbuf( thbuf *pb );


#include "symmetry.h"
static inline zahl norm(zahl r){return(r*r);}
char *sclock(long t);
/* --------------- in-out-functions ---------------------------- */
char *ckfg(tbase ic); /* Spinkonfiguration |..43210> zB: |...u.dudu> */
char *outc(cplx r);  /* complexe zahl */    
char *outphase(tphase r);
void nl(FILE *f);
void outew(FILE *f,int i);

/* m1=0: <vHn> m1=1: <nHn> */
cplx hamilton_nhv(ULong i,tvec *v0,thbuf *hbuf,int m1);
cplx fast_nhv(ULong i,tvec *v0,double *nhn,thbuf *hbuf); /* <vHn>,<nHn> */
cplx hamilton(tvec *v0,tvec *v1);         /* v1=H*v0+v1, r=<v0|H*v0> */
ULong storeh();
ULong lin(tbase i);  /* schneller ist Pointer auf fkt?!?	*/
ULong lin_if_err(tbase i);  /* schneller ist Pointer auf fkt?!?	*/
int zi(tbase kfg,int i);   /* Siz -> -1,0,1 */
int zizj(tbase kfg,int i,int j);   /* Siz*Sjz -> -1,0,1 */
tbase b_getbase(tbase ib1,struct sbase *b);

/* ================= inline - functions ======================= */

static inline int phase_eq(tphase p1,tphase p2){
#if Zahl & 4	/* verhindere Rundungsfehler! 1998-170 nicht exact!!! */
   return( (fabs(p1-p2)<1e-6)? 1: 0);}	/* Norm schneller als fabs ????? */
#else
   return( (p1==p2)? 1: 0);}
#endif

void get_symkonfig(tbase ib1,int ip,tbase *ib2,tphase *ss,int ms);
void get_sudkonfig(tbase ib1,tphase s1,tbase *ib2,tphase *ss);
    
tbase b_smallest(tbase ib1, struct sbase *b);

#endif
/* last line should be a newline, else cray-cc prints warnings */

